#include <epplet.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <signal.h>

#include "xmms/xmmsctrl.h"

#if 1
#  define D(x) do {printf("%10s | %7d:  [debug] ", __FILE__, __LINE__); printf x; fflush(stdout);} while (0)
#else
#  define D(x) ((void) 0)
#endif


#define TIME 0.1

#define HOME_PATH "/home/"
#define SKIN_PATH "/.xmms/Skins/"
#define SKIN1 "/usr/local/share/xmms/Skins/"
#define SKIN2 "/usr/share/xmms/Skins/"
#define SKINSDIRVAR "SKINSDIR"

#define EXTENSIONS 4
#define EXT1 ""
#define EXT2 ".zip"
#define EXT3 ".tar.gz"
#define EXT4 ".tgz"

int vol=100,pos=0,number=0,zero=0, place_title=0, place_artist=0;
char **paths;
gint save_volume;
gint save_place;
gint xmms_session=0;
char *xmms_cmd = "xmms &";
char *current_theme;
gchar *p,*cp,*song_artist="",*song_title="";
gboolean xmms_running = FALSE, skinchange = TRUE, scrolling = TRUE, config_showing = FALSE;
gboolean main_win = TRUE, eq_win = FALSE ,play_list_win = FALSE ;

/* GADGETS */
Epplet_gadget title_label;				/* Title Label */
Epplet_gadget vol_label;				/* Volume Label */
Epplet_gadget pos_label;				/* Position Label */
Epplet_gadget vol_slider;				/* Volume slider */
Epplet_gadget pos_slider;				/* Posistion slider */
Epplet_gadget hline1;					/* Horizontal line */
Epplet_gadget hline2;					/* Horizontal line */

Epplet_gadget back_button;				/* Back button */
Epplet_gadget play_button;				/* Play button */
Epplet_gadget pause_button;				/* Pause button */
Epplet_gadget stop_button;				/* Stop button */
Epplet_gadget next_button;				/* Next button */
Epplet_gadget eject_button;				/* Eject button */
Epplet_gadget configure_button;			/* Configure button */
Epplet_gadget help_button;				/* Help button */
Epplet_gadget quit_button;				/* Quit button */

Epplet_gadget start_button;				/* Start button */

Epplet_gadget p_follow;					/* Follow popup */
Epplet_gadget p_scroll;					/* Scroll popup */
Epplet_gadget follow_popup;				/* Follow popup-button */
Epplet_gadget scroll_popup; 			/* Scroll popup-button */

/* END GADGETS */

static void update_title_text(void)
{
	int i,w=-1,h=0;
	gboolean do_it;
	gchar *twotitle,*dum;
	gchar *title = xmms_remote_get_playlist_title(xmms_session, xmms_remote_get_playlist_pos(xmms_session));

	/* Well basically sometimes when I call the following function the values of w and v are not updated */
	while(w==-1) Epplet_textclass_get_size("EPPLET_LABEL", &w, &h, title);
/* D(("w : %d\n",w)); */

	if(w > 118)
	{
		if(scrolling)
		{
			i=strlen(title);
			dum=(char *) malloc(2*i+7);
			twotitle=dum;
			sprintf(twotitle,"%s  ***  %s",title,title);
			if(place_title > i) place_title=0;
			twotitle+=place_title;
			place_title++;
			Epplet_textclass_get_size("EPPLET_LABEL", &w, &h, twotitle);
			while(w > 118)
			{
				twotitle[strlen(twotitle)-1]='\0';
				Epplet_textclass_get_size("EPPLET_LABEL", &w, &h, twotitle);
			}
			Epplet_change_label(title_label,twotitle);
			free(dum);
		}
		else
		{
			while(w > 118)
			{
				title[strlen(title)-1]='\0';
				Epplet_textclass_get_size("EPPLET_LABEL", &w, &h, title);
			}
			Epplet_change_label(title_label,title);
		}
	}
	else Epplet_change_label(title_label,title);

	free(title);
}

static char *check(char *skinname)
{
	char *realname=NULL;
	char **extensions;
	int teller,count;
	struct stat s;
	char *total_skin_name;
	
	extensions = (char **) malloc(EXTENSIONS*sizeof(char *));
	extensions[0] = EXT1;
	extensions[1] = EXT2;
	extensions[2] = EXT3;
	extensions[3] = EXT4;

D(("Skinname : %s\n",skinname));
	for(teller=0;teller<number;teller++)
	{
		for(count=0;count<EXTENSIONS;count++)
		{
			total_skin_name =  (char *) malloc(strlen(skinname) + strlen(paths[teller]) + strlen(extensions[count]) + 1);
			sprintf(total_skin_name,"%s%s%s",paths[teller],skinname,extensions[count]);
			D(("%s\n",total_skin_name));
			if (stat(total_skin_name, &s) == 0)
			{	/* S_ISDIR(s.stmode) */
				/* S_ISREG(s.stmode) */
				realname = total_skin_name;
				teller=number;
				count=EXTENSIONS;
			}
		}	
	}
	free(extensions);
	return realname;
}

static void change_skin(void *newtheme)
{
	int i,j;
	char *new_theme;
	char *skinname,*realname;

	new_theme=newtheme;
	
	if((new_theme==NULL)||(!strcmp(newtheme,"Error: no window found")))
	{
		Epplet_send_ipc("current_theme");
		new_theme=Epplet_wait_for_ipc();
		if(new_theme==NULL)
		{
			Epplet_timer(change_skin, NULL, 10*TIME, "SKIN_TIMER");
		}
		else
		{
			if(strcmp(new_theme,current_theme)) change_skin(new_theme);	

		}
	}
	else
	{
		current_theme=new_theme;

		for(i=strlen(new_theme);i>=0;i--)
		{
			if(new_theme[i]=='/')
			{
				skinname = (char *) malloc(strlen(new_theme)-i);
				for(j=0;j<strlen(new_theme)-i;j++) skinname[j]=new_theme[i+j+1];
				i=-1;
			}
		}
		
		realname=check(skinname);
		if(realname!=NULL) xmms_remote_set_skin(xmms_session,realname);

		free(realname); 
		free(skinname); 
		free(new_theme); 
	}
}

/* FUNCTIONS */

static void check_vol_pos(void *data);

static void not_running()
{
	if(xmms_running)
	{
		xmms_running=FALSE;
		Epplet_gadget_hide(title_label);
		Epplet_gadget_hide(vol_label);
		Epplet_gadget_hide(pos_label);
		Epplet_gadget_hide(vol_slider);
		Epplet_gadget_hide(pos_slider);
/*		Epplet_gadget_hide(hline1);
		Epplet_gadget_hide(hline2);
*/		Epplet_gadget_hide(back_button);
		Epplet_gadget_hide(play_button);
		Epplet_gadget_hide(pause_button);
		Epplet_gadget_hide(stop_button);
		Epplet_gadget_hide(next_button);
		Epplet_gadget_hide(eject_button);
		Epplet_gadget_hide(configure_button);
		Epplet_gadget_hide(help_button);
		Epplet_gadget_hide(quit_button);
	}
	Epplet_gadget_show(start_button);
	
	Esync();
	
	Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
}

static void is_running()
{	
	if(!xmms_running)
	{
		xmms_running=TRUE;
		Epplet_gadget_hide(start_button);
	}
	
	Epplet_gadget_show(title_label);
	Epplet_gadget_show(vol_label);
	Epplet_gadget_show(pos_label);
	Epplet_gadget_show(vol_slider);
	Epplet_gadget_show(pos_slider);
/*	Epplet_gadget_show(hline1);
	Epplet_gadget_show(hline2);
*/	Epplet_gadget_show(back_button);
	Epplet_gadget_show(play_button);
	Epplet_gadget_show(pause_button);
	Epplet_gadget_show(stop_button);
	Epplet_gadget_show(next_button);
	Epplet_gadget_show(eject_button);
	Epplet_gadget_show(configure_button);
	Epplet_gadget_show(help_button);
	Epplet_gadget_show(quit_button);
	
	Esync();

	Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
}

static void check_vol_pos(void *data)
{
	gint volume,len;
	gint place;
	gboolean need_to_sync=FALSE,running;
	char *new_theme=NULL;
	
	running = xmms_remote_is_running(xmms_session);
	if(running)
	{
		if(!xmms_running)
		{	
			is_running();	
		}

		volume = xmms_remote_get_main_volume(xmms_session);
		len = xmms_remote_get_playlist_time(xmms_session, xmms_remote_get_playlist_pos(xmms_session));
		place =(int)(((float)xmms_remote_get_output_time(xmms_session)/(float)len) * 100.0);
		update_title_text();
		if(volume!=save_volume);
		{
			vol=volume;
			save_volume=volume;
			Epplet_gadget_data_changed(vol_slider);
		}

		if(place!=save_place);
		{
			save_place = place;
			pos=save_place;
			Epplet_gadget_data_changed(pos_slider);
		}
	}
	else
	{
		if(xmms_running)
		{
			not_running();
		}
		need_to_sync=TRUE;
	}

	if(need_to_sync) Epplet_timer(check_vol_pos, NULL, 10*TIME, "TIMER");
	else Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
}

static void vol_slider_up(void *data)
{
	if(Epplet_get_hslider_clicked(vol_slider)) Epplet_timer(vol_slider_up, NULL, TIME, "VOL_TIMER");
	else 
	{
		Epplet_change_label(vol_label,"Volume");
		Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
	}
}

static void cb_vol_slider(void *data)
{
	gchar *dum;

	sprintf(dum,"%d %%",vol);
	Epplet_change_label(vol_label,dum);
	save_volume = vol;
	xmms_remote_set_main_volume(xmms_session, save_volume);
	Epplet_remove_timer("TIMER");
	Epplet_remove_timer("VOL_TIMER");
	Epplet_timer(vol_slider_up, NULL, TIME, "VOL_TIMER");
}

static void pos_slider_up(void *data)
{
	int len;
	
	if(Epplet_get_hslider_clicked(pos_slider)) Epplet_timer(pos_slider_up, NULL, TIME, "POS_TIMER");
	else
	{
		len = xmms_remote_get_playlist_time(xmms_session, xmms_remote_get_playlist_pos(xmms_session));
		save_place=pos;
		Epplet_change_label(pos_label,"Position");
		xmms_remote_jump_to_time(xmms_session, (int)(((float)save_place * (float)len) / 100.0));
		Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
	}
}

static void cb_pos_slider(void *data)
{
	int len;
	float min1,min2,sec1,sec2;
	gchar *dum;

	dum = (char *) malloc(20);
	len = xmms_remote_get_playlist_time(xmms_session, xmms_remote_get_playlist_pos(xmms_session));
	min1 = ((float)pos*len)/6000000.0;
	sec1 = (min1-((float)floor(min1)))*60.0;
	min2 = ((float)len)/60000.0;
	sec2 = (min2-((float)floor(min2)))*60.0;
	sprintf(dum,"%d:%2.2d/%d:%2.2d",(int)(min1-0.5),(int)sec1,(int)(min2-0.5),(int)sec2);
	Epplet_change_label(pos_label,dum);
	free(dum);

	Epplet_remove_timer("TIMER");
	Epplet_remove_timer("POS_TIMER");
	Epplet_timer(pos_slider_up, NULL, TIME, "POS_TIMER");
}

static void cb_back(void *data)
{
	xmms_remote_playlist_prev(xmms_session);
}

static void cb_play(void *data)
{
	xmms_remote_play(xmms_session);
}

static void cb_pause(void *data)
{
	xmms_remote_pause(xmms_session);
}

static void cb_stop(void *data)
{
	xmms_remote_stop(xmms_session);
}

static void cb_next(void *data)
{
	xmms_remote_playlist_next(xmms_session);
}

static void cb_eject(void *data)
{
	xmms_remote_eject(xmms_session);
}

static void cb_configure(void *data)
{
	if(config_showing)
	{
		Epplet_gadget_hide(follow_popup);
		Epplet_gadget_hide(scroll_popup);
		config_showing = FALSE;
	}
	else
	{
		Epplet_gadget_show(follow_popup);
		Epplet_gadget_show(scroll_popup);
		config_showing = TRUE;
/*		xmms_remote_show_prefs_box(xmms_session);*/
	}
}

static void cb_help(void *data)
{
	Epplet_show_about("E-Xmms");
}

static void cb_start(void *data)
{
	system(xmms_cmd);
	current_theme="";

	xmms_remote_main_win_toggle(xmms_session, main_win);
	xmms_remote_eq_win_toggle(xmms_session, eq_win);
	xmms_remote_pl_win_toggle(xmms_session, play_list_win);
}

static void cb_close(void *data)
{
	Esync();
	Epplet_unremember();
	exit(0);
}

static void cb_expose(void *data, Window win, int x, int y, int w, int h)
{
	gboolean running;
	
	if(skinchange)
	{
		if((x==0)&&(y==0))
		{
D(("expose x==0 y==0\n"));
			running = xmms_remote_is_running(xmms_session);
			if(running) Epplet_timer(change_skin, NULL, 10*TIME, "SKIN_TIMER");
		}
	}
}

static void cb_follow_on(void *data)
{
	change_skin(NULL);
	skinchange = TRUE;
	Epplet_modify_config("FOLLOW_THEME", "1");
	Epplet_gadget_hide(follow_popup);
	Epplet_gadget_hide(scroll_popup);
	config_showing = FALSE;
}

static void cb_follow_off(void *data)
{
	skinchange = FALSE;
	Epplet_modify_config("FOLLOW_THEME", "0");
	Epplet_gadget_hide(follow_popup);
	Epplet_gadget_hide(scroll_popup);
	config_showing = FALSE;
}

static void cb_scroll_on(void *data)
{
	scrolling = TRUE;
	Epplet_modify_config("SCROLL", "1");
	Epplet_gadget_hide(follow_popup);
	Epplet_gadget_hide(scroll_popup);
	config_showing = FALSE;
}

static void cb_scroll_off(void *data)
{
	scrolling = FALSE;
	Epplet_modify_config("SCROLL", "0");
	Epplet_gadget_hide(follow_popup);
	Epplet_gadget_hide(scroll_popup);
	config_showing = FALSE;
}

static void cb_mouse_press(void *data, Window win, int x, int y, int b)
{
D(("x : %d, y : %d, b : %d\n",x,y,b));
	if((xmms_running)&&(y<20))
	{
		if(b == 1) /* Left button */
		{
			main_win = (main_win ? FALSE : TRUE);
			xmms_remote_main_win_toggle(xmms_session, main_win);
			if (main_win) Epplet_modify_config("MAIN", "1");
			else Epplet_modify_config("MAIN", "0");
		}
		if(b == 2) /* Middle button */
		{
			eq_win = (eq_win ? FALSE : TRUE);
			xmms_remote_eq_win_toggle(xmms_session, eq_win);
			if (eq_win) Epplet_modify_config("EQ", "1");
			else Epplet_modify_config("EQ", "0");
		}
		if(b == 3) /* Right button */
		{
			play_list_win = (play_list_win ? FALSE : TRUE);
			xmms_remote_pl_win_toggle(xmms_session, play_list_win);
			if (play_list_win) Epplet_modify_config("PLAYLIST", "1");
			else Epplet_modify_config("PLAYLIST", "0");
		}
		if(b == 4) /* Wheel up */
		{
			vol += 5;
			if(vol > 100) vol = 100;
			xmms_remote_set_main_volume(xmms_session, vol);
			Epplet_gadget_data_changed(vol_slider);
		}
		if(b == 5) /* Wheel down */
		{
			vol -= 5;
			if(vol < 0) vol = 0;
			xmms_remote_set_main_volume(xmms_session, vol);
			Epplet_gadget_data_changed(vol_slider);
		}
	}
}


int main(int argc, char **argv)
{
	gboolean xmms_running;
	char *skinsdirvar,*temp;
	char **skindirs;
	char *skinname;
	gchar *real_name;
	int t,varsize;
	int index=0;
	char *username;
	int prio;
	
	prio = getpriority (PRIO_PROCESS, getpid ());
	setpriority (PRIO_PROCESS, getpid (), prio + 10);

	atexit (Epplet_cleanup);

	Epplet_Init(PACKAGE,VERSION, "Enlightenment Xmms Epplet", 8, 3, argc, argv, 0);

	Epplet_load_config();
	if((atoi(Epplet_query_config_def("FOLLOW_THEME","1")))==0) skinchange=FALSE;
	if((atoi(Epplet_query_config_def("SCROLL","0")))==0) scrolling=FALSE;
	if((atoi(Epplet_query_config_def("MAIN","1")))==0) main_win=FALSE;
	if((atoi(Epplet_query_config_def("EQ","0")))==1) eq_win=TRUE;
	if((atoi(Epplet_query_config_def("PLAYLIST","0")))==1) play_list_win=TRUE;	
	
	vol=100;
	pos=0;

	title_label = Epplet_create_label(5, 3, "Title",0);
	vol_label = Epplet_create_label(20, 13, "Volume",0);
	pos_label = Epplet_create_label(79, 13, "Position",0);
	vol_slider = Epplet_create_hslider(6, 22, 58, 0, 100, 1, 10, &vol, cb_vol_slider, NULL);
	pos_slider = Epplet_create_hslider(66, 22, 58, 0, 100, 1, 10, &pos, cb_pos_slider, NULL);

	back_button = Epplet_create_button(NULL, NULL, 5, 32, 12, 12, "PREVIOUS", 0, NULL, cb_back, NULL);
	play_button = Epplet_create_button(NULL, NULL, 18, 32, 12, 12, "PLAY", 0, NULL, cb_play, NULL);
	pause_button = Epplet_create_button(NULL, NULL, 31, 32, 12, 12, "PAUSE", 0, NULL, cb_pause, NULL);
	stop_button = Epplet_create_button(NULL, NULL, 44, 32, 12, 12, "STOP", 0, NULL, cb_stop, NULL);
	next_button = Epplet_create_button(NULL, NULL, 57, 32, 12, 12, "NEXT", 0, NULL, cb_next, NULL);
	eject_button = Epplet_create_button(NULL, NULL, 70, 32, 12, 12, "EJECT", 0, NULL, cb_eject, NULL);
	configure_button = Epplet_create_button(NULL, NULL, 85, 32, 12, 12, "CONFIGURE", 0, NULL, cb_configure, NULL);
	help_button = Epplet_create_button(NULL, NULL, 98, 32, 12, 12, "HELP", 0, NULL, cb_help, NULL);
	quit_button = Epplet_create_button(NULL, NULL, 112, 32, 12, 12, "CLOSE", 0, NULL, cb_close, NULL);

	start_button = Epplet_create_button("Start Xmms", NULL, 10, 8, 107, 31, NULL, 0, NULL, cb_start, NULL);

	p_follow = Epplet_create_popup();
	Epplet_add_popup_entry(p_follow, "On", NULL, cb_follow_on, NULL);
	Epplet_add_popup_entry(p_follow, "Off", NULL, cb_follow_off, NULL);
	Epplet_gadget_hide(follow_popup = Epplet_create_popupbutton("Follow theme", NULL, 3, 3, 58, 12, NULL, p_follow));

	p_scroll = Epplet_create_popup();
	Epplet_add_popup_entry(p_scroll, "On", NULL, cb_scroll_on, NULL);
	Epplet_add_popup_entry(p_scroll, "Off", NULL, cb_scroll_off, NULL);
	Epplet_gadget_hide(scroll_popup = Epplet_create_popupbutton("Scrolling", NULL, 66, 3, 58, 12, NULL, p_scroll));

	xmms_running = xmms_remote_is_running(xmms_session);

	if(xmms_running)
	{
		is_running();
		vol=xmms_remote_get_main_volume(xmms_session);
		Epplet_gadget_data_changed(vol_slider);

		xmms_remote_main_win_toggle(xmms_session, main_win);
		xmms_remote_eq_win_toggle(xmms_session, eq_win);
		xmms_remote_pl_win_toggle(xmms_session, play_list_win);
	}
	else
	{
		not_running();
	}

	if(skinchange)
	{
		Epplet_send_ipc("current_theme");
		current_theme=Epplet_wait_for_ipc();

D(("Current theme : %s\n",current_theme));

		temp = getenv(SKINSDIRVAR);
		if(temp != NULL)
		{
			int teller,previous=-1,var;
			skinsdirvar = (char *) malloc(strlen(temp)+1);
			sprintf(skinsdirvar,"%s:",temp);
			var=strlen(skinsdirvar);
			D(("Skinsdirvar : %s, size : %d\n",skinsdirvar,var));
			for(teller=0;teller<var;teller++)
			{
				if((skinsdirvar[teller]==':')&&(teller!=0))
				{
					D(("%d - %d\n",teller,previous));
					if((teller-previous)>1) number++;
					previous=teller;
				}
			}
			D(("Number : %d\n",number));
			number=0;
			previous=-1;
			skindirs = (char **) malloc(number*sizeof(char *));
			for(teller=0;teller<var;teller++)
			{
				if((skinsdirvar[teller]==':')&&(teller!=0))
				{
					D(("%d - %d\n",teller,previous));
					if((teller-previous)>1)
					{
						int size,t;
						previous ++;
						size=teller-previous;
						D(("end char : %c\n",skinsdirvar[teller-1]));
						if(skinsdirvar[teller-1]!='/')
						{
							skindirs[number] = (char *) malloc(size+2);
							for(t=0;t<size;t++) skindirs[number][t] = skinsdirvar[t+previous];
							skindirs[number][size]='/';
							skindirs[number][size+1]='\0';
						}
						else
						{
							skindirs[number] = (char *) malloc(size+1);
							for(t=0;t<size;t++) skindirs[number][t] = skinsdirvar[t+previous];
							skindirs[number][size]='\0';
						}
						D(("Skindir[%d] = %s\n",number,skindirs[number]));
						number++;
					}
					previous=teller;
				}
			}
		}
		D(("NUmber : %d\n",number));
		varsize=number;
		number ++;	
		username = getenv("LOGNAME");
		if(!username) username = getenv("USER");
		if(username) number++;
	
		paths = (char **) malloc(number*sizeof(char *));
		
		for(index=0;index<varsize;index++)
		{
			paths[index] = skindirs[index];
		}
	
		if(username)
		{
			paths[index] = (char *) malloc(sizeof(HOME_PATH) + sizeof(SKIN_PATH) + strlen(username) + 1);
			sprintf(paths[index++],HOME_PATH"%s"SKIN_PATH,username);
		}
	
		paths[index] = (char *) malloc(sizeof(SKIN1));
		sprintf(paths[index++],SKIN1);
	
		paths[index] = (char *) malloc(sizeof(SKIN2));
		sprintf(paths[index++],SKIN2);
		number=index;
		
		if(xmms_running) change_skin((void *)current_theme);
		Epplet_register_expose_handler(cb_expose, NULL);
	}

	Epplet_register_button_press_handler(cb_mouse_press, NULL);

	Epplet_show();
	Epplet_Loop();
	return 0;
}
